#include "string.h"
#include "stdio.h"
#include "stdlib.h"

#define proccpuinfo "/proc/cpuinfo"


struct cpu_heirarchy_info{
    int max_present_cpu;
    int max_online_cpu;
	int num_sockets;
    int* core_state;
    int* package_num;
    int* sibling_num;
};


int get_number_of_present_cpu()
{
    FILE *fp;
    char tmp_str[200];
    char command_str[200];
    sprintf(command_str,"cat /sys/devices/system/cpu/present > /tmp/CPUspresent.txt");
    system(command_str);
    fp = fopen("/tmp/CPUspresent.txt","r");
    fgets (tmp_str, 200, fp);
    //printf("%s\n",tmp_str);
    char* cpu_present = strtok(tmp_str,",");
    int start_core, end_core;
    sscanf(cpu_present,"%d-%d", &start_core, &end_core);
    //printf("%d --- %d\n", start_core, end_core);
    fclose(fp);
    return(end_core+1);
}

void get_online_cpus(struct cpu_heirarchy_info* chi)
{
    FILE *fp;
    int i;
    char tmp_str[200];
    char command_string[200];
    sprintf(command_string,"cat /sys/devices/system/cpu/online > /tmp/CPUspresent.txt");

    system(command_string);
    fp = fopen("/tmp/CPUspresent.txt","r");
    fgets (tmp_str, 200, fp);
    fclose (fp);
    
    char* cpu_present;
    cpu_present = strtok(tmp_str,",");
    int start_core, end_core;

	chi->max_online_cpu=0;
    while(cpu_present != NULL){
        //int num_cores = atoi (tmp_str);
        //printf("number of Cores present %s\n",cpu_present);
        sscanf(cpu_present,"%d-%d", &start_core, &end_core);
        for (i=start_core;i<=end_core;i++){
    	    chi->core_state[i]=1;
			chi->max_online_cpu++;
		}
        //printf("%d --- %d\n", start_core, end_core);
        cpu_present = strtok(NULL, ",");
    }
}

void get_siblings_list(struct cpu_heirarchy_info* chi)
{
	int i;
	int	sib_1, sib_2;
	FILE *fp;
	char command_string[200];
	char tmp_str[200], *sib_list;
	sprintf(command_string,"cat /sys/devices/system/cpu/cpu*/topology/thread_siblings_list > /tmp/SIBLINGSlist.txt");

	system(command_string);
	fp = fopen("/tmp/SIBLINGSlist.txt","r");


	for(i=0; i < chi->max_online_cpu ; i++){
   		fgets(tmp_str, 200, fp);
//		printf("%s\n",tmp_str);
	    sib_list = strtok(tmp_str,",");
		
		sib_1 = atoi(sib_list);
		sib_2 = sib_1;
		while(sib_list != NULL){
			sib_list = strtok(NULL,",");
			if (sib_list != NULL)
				sib_2 = atoi(sib_list);
		}
//	    printf("-%d, %d\n", sib_1, sib_2);
		chi->sibling_num[sib_1] = sib_2;
		chi->sibling_num[sib_2] = sib_1;
	}
	fclose(fp);
}

void get_package_ids(struct cpu_heirarchy_info* chi)
{
	int i;
	int	sib_1, sib_2;
	FILE *fp;
	char command_string[200];
	char tmp_str[200], *sib_list;

	chi->num_sockets=0;
	for(i=0; i < chi->max_present_cpu ; i++){
		if(chi->core_state[i]==1){
			sprintf(command_string,"cat /sys/devices/system/cpu/cpu%d/topology/physical_package_id > /tmp/cpu_phy_id.txt",i);
			system(command_string);
		    fp = fopen("/tmp/cpu_phy_id.txt","r");
		    fgets (tmp_str, 200, fp);
			chi->package_num[i] = atoi(tmp_str);
			if (chi->num_sockets < chi->package_num[i])
				chi->num_sockets = chi->package_num[i];
		}
	}
	chi->num_sockets = chi->num_sockets+1;
	fclose(fp);
}



void print_cpu_list(struct cpu_heirarchy_info chi)
{
    int i;
    for( i=0; i<chi.max_present_cpu; i++){
		if(chi.core_state[i]==0)
		    printf("CPU %d: offline, Package %d\n", i, chi.package_num[i]);
		if(chi.core_state[i]==1)
			if (i==chi.sibling_num[i])
				printf("CPU %d: online, Package %d, sibling offline\n", i, chi.package_num[i]);				
			else
				printf("CPU %d: online, Package %d, sibling %d\n", i, chi.package_num[i], chi.sibling_num[i]);
    }
}

void construct_cpu_hierarchy(struct cpu_heirarchy_info *chi)
{ 
  char tmp_str[200];
  char command_string[200];

  chi->max_present_cpu = get_number_of_present_cpu();
  chi->core_state  = (int*)calloc(chi->max_present_cpu,sizeof(int));
  chi->package_num = (int*)calloc(chi->max_present_cpu,sizeof(int));
  chi->sibling_num = (int*)calloc(chi->max_present_cpu,sizeof(int));

  get_online_cpus(chi);
  get_siblings_list(chi);
  get_package_ids(chi);

  printf("Number of CPU Sockets %d\n", chi->num_sockets);
  printf("Number of CPU present %d\n", chi->max_present_cpu);
  printf("Number of CPU online  %d\n", chi->max_online_cpu);

}


/*int main()
{
	struct 	cpu_heirarchy_info chi;
	while(1){
		construct_cpu_hierarchy(&chi);
		print_cpu_list(chi);
		sleep(1);
	}
}*/
